SpartanSmolReader
Date: 2019-10-22

org.jmol.adapter.readers.spartan

## Class SpartanSmolReader

- java.lang.Object
- - org.jmol.adapter.smarter.AtomSetCollectionReader
  - - org.jmol.adapter.readers.quantum.BasisFunctionReader
    - - org.jmol.adapter.readers.spartan.SpartanInputReader
      - - org.jmol.adapter.readers.spartan.SpartanSmolReader

- All Implemented Interfaces:
    javajs.api.GenericLineReader

      public class SpartanSmolReader
      extends SpartanInputReader

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.jmol.adapter.readers.quantum.BasisFunctionReader

      `BasisFunctionReader.MOEnergySorter`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static java.lang.String` | `endCheck`
    `private boolean` | `espCharges`
    `private boolean` | `haveCharges`
    `private boolean` | `iHaveModelStatement`
    `private boolean` | `iHaveNewDir`
    `private boolean` | `inputOnly`
    `private boolean` | `isCompoundDocument`
    `private boolean` | `isInputFirst`
    `private boolean` | `natCharges`
    `(package private) SpartanArchive` | `spartanArchive`
    `private java.lang.String` | `title`
    `(package private) java.util.Map<java.lang.String,java.lang.String>` | `titles`

    - ### Fields inherited from class org.jmol.adapter.readers.spartan.SpartanInputReader

      `bondData, constraints, modelAtomCount`

    - ### Fields inherited from class org.jmol.adapter.readers.quantum.BasisFunctionReader

      `alphaBeta, dfCoefMaps, ignoreMOs, moData, nCoef, nOrbitals, orbitals, shells`

    - ### Fields inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addedData, addedDataKey, addVibrations, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, binaryDoc, bsFilter, bsModels, calculationType, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterHetero, fixJavaFloat, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isTrajectory, latticeCells, latticeScaling, latticeType, line, lstNCS, matUnitCellOrientation, modDim, modelNumber, ms, mustFinalizeModelSet, next, out, packingError, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SpartanSmolReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `checkLine()`
    `protected void` | `finalizeSubclassReader()` optional reader-specific method run first.
    `protected void` | `initializeReader()`
    `private void` | `makeNewAtomSet()`
    `private java.lang.String` | `readArchive()`
    `private java.lang.String` | `readArchiveHeader()`
    `private void` | `readMyTransform()`
    `private void` | `readOutput()`
    `private void` | `readProperties()`
    `private void` | `setCharges()`
    `void` | `setEnergy(float value)`

    - ### Methods inherited from class org.jmol.adapter.readers.spartan.SpartanInputReader

      `readInputRecords`

    - ### Methods inherited from class org.jmol.adapter.readers.quantum.BasisFunctionReader

      `canonicalizeQuantumSubshellTag, clearOrbitals, discardPreviousAtoms, enableShell, filterMO, fixSlaterTypes, getDfCoefMaps, getDFMap, getQuantumShellTag, getQuantumShellTagID, getQuantumShellTagIDSpherical, setMO`

    - ### Methods inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addSites, addSiteScript, appendLoadNote, appendUunitCellInfo, applySymmetryAndSetTrajectory, applySymTrajASCR, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassSymmetry, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFortranFormatLengths, getInterface, getNewSymmetry, getStrings, getSymmetry, getTokens, getTokensFloat, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### iHaveModelStatement

          private boolean iHaveModelStatement

    - #### isCompoundDocument

          private boolean isCompoundDocument

    - #### inputOnly

          private boolean inputOnly

    - #### espCharges

          private boolean espCharges

    - #### natCharges

          private boolean natCharges

    - #### isInputFirst

          private boolean isInputFirst

    - #### iHaveNewDir

          private boolean iHaveNewDir

    - #### endCheck

          private static final java.lang.String endCheck

      See Also:
        Constant Field Values

    - #### title

          private java.lang.String title

    - #### spartanArchive

          SpartanArchive spartanArchive

    - #### titles

          java.util.Map<java.lang.String,java.lang.String> titles

    - #### haveCharges

          private boolean haveCharges

  - ### Constructor Detail

    - #### SpartanSmolReader

          public SpartanSmolReader()

  - ### Method Detail

    - #### initializeReader

          protected void initializeReader()
                                   throws java.lang.Exception

      Overrides:
        `initializeReader` in class `AtomSetCollectionReader`
      Throws:
        `java.lang.Exception`

    - #### checkLine

          protected boolean checkLine()
                               throws java.lang.Exception

      Overrides:
        `checkLine` in class `AtomSetCollectionReader`
      Returns:
        true if need to read new line
      Throws:
        `java.lang.Exception`

    - #### makeNewAtomSet

          private void makeNewAtomSet()

    - #### finalizeSubclassReader

          protected void finalizeSubclassReader()
                                         throws java.lang.Exception

      Description copied from class: `AtomSetCollectionReader`
      optional reader-specific method run first.
      Overrides:
        `finalizeSubclassReader` in class `AtomSetCollectionReader`
      Throws:
        `java.lang.Exception`

    - #### readMyTransform

          private void readMyTransform()
                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readOutput

          private void readOutput()
                           throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readArchive

          private java.lang.String readArchive()
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### setCharges

          private void setCharges()

    - #### readProperties

          private void readProperties()
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readArchiveHeader

          private java.lang.String readArchiveHeader()
                                              throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### setEnergy

          public void setEnergy(float value)